#include <LiquidCrystal.h>

LiquidCrystal lcd(1, 2, 4, 5, 6, 7);
const int buttonPin = 9;
const int buttonPin2 = 10;
int buttonState = 0;
int buttonState2 = 0;
int gameTimeIndex = 0;
float gameTimes[] = {3, 5, 15, 60}; // Időtartamok, percekben
int currentPlayer = 0; // Jelenlegi játékos (0 vagy 1)
unsigned long startTime = 0; // Az időmérő indításának időpontja
unsigned long elapsedTime = 0; // Eltelt idő
bool isInMenu = true;
unsigned long player1ElapsedTime = 0;
unsigned long player2ElapsedTime = 0;
 unsigned long remainingTime=0;
 unsigned long isondisplay=0;

void setup() {
  lcd.begin(16, 2);
  pinMode(buttonPin, INPUT_PULLUP);
  pinMode(buttonPin2, INPUT_PULLUP);
}
void loop() {

  if (isInMenu) {
    // Menü üzemmód
    if (isondisplay==0){
    lcd.clear();
    lcd.print("Choose time");
    lcd.setCursor(0, 1);
    if (gameTimes[gameTimeIndex] < 10) {
      lcd.print("0");
    }
    lcd.print(gameTimes[gameTimeIndex]);
    lcd.print(":00");
    isondisplay=1;
    }
    if (buttonState != digitalRead(buttonPin)) {
      // Gomb 1 lenyomva, változtatjuk az időtartamot
      isondisplay=0;
      buttonState = !buttonState;
      if (buttonState == LOW) {
        gameTimeIndex = (gameTimeIndex + 1) % (sizeof(gameTimes) / sizeof(gameTimes[0]));
        delay(500); // Várunk egy rövid ideig, hogy ne érzékelje megismételt gombnyomásnak
      }
    }

    if (buttonState2 != digitalRead(buttonPin2)) {
      // Gomb 2 lenyomva, elindítjuk az időmérést
      buttonState2 = !buttonState2;
      if (buttonState2 == LOW) {
        currentPlayer = 0;
        elapsedTime = 0;
        startTime = millis();
        isInMenu = false;
        lcd.clear();
        lcd.print("Player 1");
        delay(1000); // Várunk egy másodpercet, hogy az üzenet látható legyen
      }
    }
  }
     else {
       isondisplay=0;
    // Játék üzemmódTi
    if (currentPlayer == 0) {
      // Jelenlegi játékos 0, az időt csak ekkor növeljük
      unsigned long currentTime = millis();
      elapsedTime += currentTime - startTime;
      startTime = currentTime;
      remainingTime = (gameTimes[gameTimeIndex] * 60 - elapsedTime / 1000) * 1000;
    } else {
      // Jelenlegi játékos 1, az időt csak ekkor növeljük
      unsigned long currentTime = millis();
      player2ElapsedTime += currentTime - startTime;
      startTime = currentTime;
      remainingTime = (gameTimes[gameTimeIndex] * 60 - player2ElapsedTime / 1000) * 1000;
    }

    


 if (remainingTime <= 0) {
  // Idő lejárt
  lcd.clear();
      if(currentPlayer==0){
        lcd.print("Player 1");
      }
      else{
        lcd.print("Player 2");
      }
  lcd.setCursor(0, 1);
  lcd.print("Time's Up");
  delay(1000); // Várunk egy másodpercet, hogy az üzenet látható legyen
  while (digitalRead(buttonPin) == LOW && digitalRead(buttonPin2) == LOW) {
    // Várakozás, amíg valamelyik gomb meg nem nyomódik
  }
  delay(320);
  isInMenu = true;
  lcd.clear();
  return;

}
     else {
      // Idő kiírása
      
      lcd.setCursor(0, 1);
      lcd.print("Time: ");
      if (remainingTime / 1000 / 60 < 10) {
        lcd.print("0");
      }
      lcd.print(remainingTime / 1000 / 60);
      lcd.print(":");
      if ((remainingTime / 1000) % 60 < 10) {
        lcd.print("0");
      }
      lcd.print((remainingTime / 1000) % 60);
      
    }

    if (buttonState != digitalRead(buttonPin) && buttonState2 != digitalRead(buttonPin2)) {
      // Mindkét gomb egyszerre lenyomva, visszatérünk a menübe
      buttonState = !buttonState;
      buttonState2 = !buttonState2;
           if (buttonState == LOW && buttonState2 == LOW) {
        isInMenu = true;
        lcd.clear();
      }
    }

   if (buttonState2 != digitalRead(buttonPin2) && currentPlayer==0) {
  // Gomb 2 lenyomva, játékos váltás és idejének rögzítése
  buttonState2 = !buttonState2;
  if (buttonState2 == LOW) {
    currentPlayer = 1;
    startTime = millis();
    lcd.setCursor(0, 0);
    lcd.print("Player 2        "); // Player 2 szöveg kiírása
  }
}

if (buttonState != digitalRead(buttonPin) && currentPlayer == 1) {
  // Gomb 1 lenyomva, játékos váltás és idejének rögzítése
  buttonState = !buttonState;
  if (buttonState == LOW) {
    currentPlayer = 0;
    startTime = millis();
    lcd.setCursor(0, 0);
    lcd.print("Player 1        "); // Player 1 szöveg kiírása
  }
    }
  }
}

   
